"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PhotoView = void 0;

var _react = _interopRequireWildcard(require("react"));

var _videoRenderer = require("../utils/videoRenderer");

var _photoView = require("../utils/photoView");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const PhotoView = props => {
  const {
    onRequestClose
  } = props;

  const _onRequestClose = (0, _react.useCallback)(() => {
    if (_videoRenderer.videoRef.current) {
      var _videoRef$current;

      (_videoRef$current = _videoRenderer.videoRef.current) === null || _videoRef$current === void 0 ? void 0 : _videoRef$current.unloadAsync();
    }

    onRequestClose();
  }, [onRequestClose]);

  const _onImageIndexChange = (0, _react.useCallback)(() => {
    if (_videoRenderer.videoRef.current) {
      var _videoRef$current2;

      (_videoRef$current2 = _videoRenderer.videoRef.current) === null || _videoRef$current2 === void 0 ? void 0 : _videoRef$current2.unloadAsync();
    }
  }, []);

  if (_photoView.PhotoView) {
    return /*#__PURE__*/_react.default.createElement(_photoView.PhotoView, _extends({}, props, {
      onRequestClose: _onRequestClose,
      onImageIndexChange: _onImageIndexChange,
      swipeToCloseEnabled: true
    }));
  }

  return null;
};

exports.PhotoView = PhotoView;
//# sourceMappingURL=PhotoView.js.map