"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.VideoThumbnail = VideoThumbnail;

var _react = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _reactNativeGestureHandler = require("react-native-gesture-handler");

var _Video = require("./Video");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function VideoThumbnail(_ref) {
  var _media$videoOptions3, _media$videoOptions4;

  let {
    media,
    isSelected
  } = _ref;
  const [showVideo, setShowVideo] = (0, _react.useState)(false);
  const [showThumbnail, setShowThumbnail] = (0, _react.useState)(false);
  const playIcon = (0, _react.useMemo)(() => require('../assets/icons/play.png'), []);
  (0, _react.useEffect)(() => {
    return () => {
      setShowVideo(false);
    };
  }, []);
  const onPressThumbnail = (0, _react.useCallback)(() => {
    setShowVideo(true);
  }, []);
  (0, _react.useEffect)(() => {
    _reactNative.InteractionManager.runAfterInteractions(() => {
      var _media$videoOptions;

      if (media !== null && media !== void 0 && (_media$videoOptions = media.videoOptions) !== null && _media$videoOptions !== void 0 && _media$videoOptions.thumbnail) {
        var _media$videoOptions2;

        _reactNative.Image.prefetch(media === null || media === void 0 ? void 0 : (_media$videoOptions2 = media.videoOptions) === null || _media$videoOptions2 === void 0 ? void 0 : _media$videoOptions2.thumbnail).then(() => {
          setShowThumbnail(true);
        });
      } else {
        setShowThumbnail(true);
      }
    });
  }, [media === null || media === void 0 ? void 0 : (_media$videoOptions3 = media.videoOptions) === null || _media$videoOptions3 === void 0 ? void 0 : _media$videoOptions3.thumbnail]);

  if (showVideo) {
    return /*#__PURE__*/_react.default.createElement(_Video.Video, {
      media: media
    });
  }

  if (!showThumbnail) {
    /*#__PURE__*/
    _react.default.createElement(_reactNative.View, {
      style: styles.spinner
    }, /*#__PURE__*/_react.default.createElement(_reactNative.ActivityIndicator, {
      size: "small"
    }));
  }

  return /*#__PURE__*/_react.default.createElement(_reactNativeGestureHandler.TouchableWithoutFeedback, {
    onPress: isSelected ? onPressThumbnail : () => null
  }, /*#__PURE__*/_react.default.createElement(_reactNative.ImageBackground, {
    source: {
      uri: media === null || media === void 0 ? void 0 : (_media$videoOptions4 = media.videoOptions) === null || _media$videoOptions4 === void 0 ? void 0 : _media$videoOptions4.thumbnail
    },
    style: !isSelected ? styles.container : styles.isSelecetedContainer,
    imageStyle: styles.contentContainer
  }, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: styles.overlay
  }), /*#__PURE__*/_react.default.createElement(_reactNative.Image, {
    source: playIcon,
    style: !isSelected ? styles.image : styles.isSelectedImage
  })));
}

const styles = _reactNative.StyleSheet.create({
  container: {
    width: 110,
    height: 100,
    borderRadius: 15,
    marginRight: 10,
    marginBottom: 10,
    justifyContent: 'center',
    alignItems: 'center',
    alignContent: 'center'
  },
  isSelecetedContainer: {
    width: 300,
    height: 300,
    borderRadius: 15,
    marginRight: 10,
    marginBottom: 10,
    justifyContent: 'center',
    alignItems: 'center',
    alignContent: 'center'
  },
  contentContainer: {
    borderRadius: 15
  },
  image: {
    width: 25,
    height: 25
  },
  isSelectedImage: {
    width: 50,
    height: 50
  },
  overlay: {
    position: 'absolute',
    top: 0,
    left: 0,
    right: 0,
    bottom: 0,
    backgroundColor: 'rgba(0, 0, 0, 0.5)',
    borderRadius: 15
  },
  spinner: {
    flex: 1,
    justifyContent: 'center',
    alignItems: 'center',
    alignContent: 'center'
  }
});
//# sourceMappingURL=VideoThumbnail.js.map