"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.videoRendererExpo = exports.videoRenderer = exports.videoRef = exports.RenderVideoExpo = exports.RenderVideo = void 0;

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const videoRef = /*#__PURE__*/_react.default.createRef();

exports.videoRef = videoRef;
let videoRendererExpo;
exports.videoRendererExpo = videoRendererExpo;
let videoRenderer;
exports.videoRenderer = videoRenderer;

try {
  exports.videoRendererExpo = videoRendererExpo = require('expo-av');
} catch {
  try {
    exports.videoRenderer = videoRenderer = require('react-native-video');
  } catch {
    console.warn('expo-image-picker or react-native-image-picker not found. Please install it to use this feature.');
  }
}

const RenderVideo = /*#__PURE__*/_react.default.forwardRef((props, _ref) => {
  if (videoRenderer) {
    return /*#__PURE__*/_react.default.createElement(videoRenderer.default, _extends({}, props, {
      ref: videoRef
    }));
  }

  return null;
});

exports.RenderVideo = RenderVideo;

const RenderVideoExpo = /*#__PURE__*/_react.default.forwardRef((props, _ref) => {
  if (videoRenderer) {
    return /*#__PURE__*/_react.default.createElement(videoRendererExpo.Video, _extends({}, props, {
      ref: videoRef
    }));
  }

  return null;
});

exports.RenderVideoExpo = RenderVideoExpo;
//# sourceMappingURL=videoRenderer.js.map