import React, { useCallback, useEffect, useMemo, useState } from 'react';
import { ActivityIndicator, Image, ImageBackground, InteractionManager, StyleSheet, View } from 'react-native';
import { TouchableWithoutFeedback } from 'react-native-gesture-handler';
import { Video } from './Video';
export function VideoThumbnail(_ref) {
  var _media$videoOptions3, _media$videoOptions4;

  let {
    media,
    isSelected
  } = _ref;
  const [showVideo, setShowVideo] = useState(false);
  const [showThumbnail, setShowThumbnail] = useState(false);
  const playIcon = useMemo(() => require('../assets/icons/play.png'), []);
  useEffect(() => {
    return () => {
      setShowVideo(false);
    };
  }, []);
  const onPressThumbnail = useCallback(() => {
    setShowVideo(true);
  }, []);
  useEffect(() => {
    InteractionManager.runAfterInteractions(() => {
      var _media$videoOptions;

      if (media !== null && media !== void 0 && (_media$videoOptions = media.videoOptions) !== null && _media$videoOptions !== void 0 && _media$videoOptions.thumbnail) {
        var _media$videoOptions2;

        Image.prefetch(media === null || media === void 0 ? void 0 : (_media$videoOptions2 = media.videoOptions) === null || _media$videoOptions2 === void 0 ? void 0 : _media$videoOptions2.thumbnail).then(() => {
          setShowThumbnail(true);
        });
      } else {
        setShowThumbnail(true);
      }
    });
  }, [media === null || media === void 0 ? void 0 : (_media$videoOptions3 = media.videoOptions) === null || _media$videoOptions3 === void 0 ? void 0 : _media$videoOptions3.thumbnail]);

  if (showVideo) {
    return /*#__PURE__*/React.createElement(Video, {
      media: media
    });
  }

  if (!showThumbnail) {
    /*#__PURE__*/
    React.createElement(View, {
      style: styles.spinner
    }, /*#__PURE__*/React.createElement(ActivityIndicator, {
      size: "small"
    }));
  }

  return /*#__PURE__*/React.createElement(TouchableWithoutFeedback, {
    onPress: isSelected ? onPressThumbnail : () => null
  }, /*#__PURE__*/React.createElement(ImageBackground, {
    source: {
      uri: media === null || media === void 0 ? void 0 : (_media$videoOptions4 = media.videoOptions) === null || _media$videoOptions4 === void 0 ? void 0 : _media$videoOptions4.thumbnail
    },
    style: !isSelected ? styles.container : styles.isSelecetedContainer,
    imageStyle: styles.contentContainer
  }, /*#__PURE__*/React.createElement(View, {
    style: styles.overlay
  }), /*#__PURE__*/React.createElement(Image, {
    source: playIcon,
    style: !isSelected ? styles.image : styles.isSelectedImage
  })));
}
const styles = StyleSheet.create({
  container: {
    width: 110,
    height: 100,
    borderRadius: 15,
    marginRight: 10,
    marginBottom: 10,
    justifyContent: 'center',
    alignItems: 'center',
    alignContent: 'center'
  },
  isSelecetedContainer: {
    width: 300,
    height: 300,
    borderRadius: 15,
    marginRight: 10,
    marginBottom: 10,
    justifyContent: 'center',
    alignItems: 'center',
    alignContent: 'center'
  },
  contentContainer: {
    borderRadius: 15
  },
  image: {
    width: 25,
    height: 25
  },
  isSelectedImage: {
    width: 50,
    height: 50
  },
  overlay: {
    position: 'absolute',
    top: 0,
    left: 0,
    right: 0,
    bottom: 0,
    backgroundColor: 'rgba(0, 0, 0, 0.5)',
    borderRadius: 15
  },
  spinner: {
    flex: 1,
    justifyContent: 'center',
    alignItems: 'center',
    alignContent: 'center'
  }
});
//# sourceMappingURL=VideoThumbnail.js.map